Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/LBC/mppini.F90	(revision 13727)
@@ -8,6 +8,6 @@
    !!            8.0  !  1998-05  (M. Imbard, J. Escobar, L. Colombet )  SHMEM and MPI versions
    !!  NEMO      1.0  !  2004-01  (G. Madec, J.M Molines)  F90 : free form , north fold jpni > 1
-   !!            3.4  ! 2011-10  (A. C. Coward, NOCS & J. Donners, PRACE) add mpp_init_nfdcom
-   !!            3.   ! 2013-06  (I. Epicoco, S. Mocavero, CMCC) mpp_init_nfdcom: setup avoiding MPI communication 
+   !!            3.4  !  2011-10  (A. C. Coward, NOCS & J. Donners, PRACE)  add init_nfdcom
+   !!            3.   !  2013-06  (I. Epicoco, S. Mocavero, CMCC)  init_nfdcom: setup avoiding MPI communication 
    !!            4.0  !  2016-06  (G. Madec)  use domain configuration file instead of bathymetry file
    !!            4.0  !  2017-06  (J.M. Molines, T. Lovato) merge of mppini and mppini_2
@@ -15,15 +15,13 @@
 
    !!----------------------------------------------------------------------
-   !!  mpp_init          : Lay out the global domain over processors with/without land processor elimination
-   !!  mpp_init_mask     : Read global bathymetric information to facilitate land suppression
-   !!  mpp_init_ioipsl   : IOIPSL initialization in mpp 
-   !!  mpp_init_partition: Calculate MPP domain decomposition
-   !!  factorise         : Calculate the factors of the no. of MPI processes
-   !!  mpp_init_nfdcom   : Setup for north fold exchanges with explicit point-to-point messaging
+   !!  mpp_init       : Lay out the global domain over processors with/without land processor elimination
+   !!      init_ioipsl: IOIPSL initialization in mpp 
+   !!      init_nfdcom: Setup for north fold exchanges with explicit point-to-point messaging
+   !!      init_doloop: set the starting/ending indices of DO-loop used in do_loop_substitute 
    !!----------------------------------------------------------------------
    USE dom_oce        ! ocean space and time domain
    USE bdy_oce        ! open BounDarY  
    !
-   USE lbcnfd  , ONLY : isendto, nsndto, nfsloop, nfeloop   ! Setup of north fold exchanges 
+   USE lbcnfd  , ONLY : isendto, nsndto ! Setup of north fold exchanges 
    USE lib_mpp        ! distribued memory computing library
    USE iom            ! nemo I/O library 
@@ -34,8 +32,11 @@
    PRIVATE
 
-   PUBLIC mpp_init       ! called by opa.F90
-
-   INTEGER :: numbot = -1  ! 'bottom_level' local logical unit
-   INTEGER :: numbdy = -1  ! 'bdy_msk'      local logical unit
+   PUBLIC   mpp_init       ! called by nemogcm.F90
+   PUBLIC   mpp_getnum     ! called by prtctl
+   PUBLIC   mpp_basesplit  ! called by prtctl
+   PUBLIC   mpp_is_ocean   ! called by prtctl
+   
+   INTEGER ::   numbot = -1   ! 'bottom_level' local logical unit
+   INTEGER ::   numbdy = -1   ! 'bdy_msk'      local logical unit
    
    !!----------------------------------------------------------------------
@@ -61,4 +62,7 @@
       !!----------------------------------------------------------------------
       !
+      nn_hls = 1
+      jpiglo = Ni0glo + 2 * nn_hls
+      jpjglo = Nj0glo + 2 * nn_hls
       jpimax = jpiglo
       jpjmax = jpjglo
@@ -66,19 +70,13 @@
       jpj    = jpjglo
       jpk    = jpkglo
-      jpim1  = jpi-1                                            ! inner domain indices
-      jpjm1  = jpj-1                                            !   "           "
-      jpkm1  = MAX( 1, jpk-1 )                                  !   "           "
+      jpim1  = jpi-1                         ! inner domain indices
+      jpjm1  = jpj-1                         !   "           "
+      jpkm1  = MAX( 1, jpk-1 )               !   "           "
       jpij   = jpi*jpj
       jpni   = 1
       jpnj   = 1
       jpnij  = jpni*jpnj
-      nimpp  = 1           ! 
+      nimpp  = 1
       njmpp  = 1
-      nlci   = jpi
-      nlcj   = jpj
-      nldi   = 1
-      nldj   = 1
-      nlei   = jpi
-      nlej   = jpj
       nbondi = 2
       nbondj = 2
@@ -90,4 +88,6 @@
       l_Jperio = jpnj == 1 .AND. (jperio == 2 .OR. jperio == 7)
       !
+      CALL init_doloop                       ! set start/end indices or do-loop depending on the halo width value (nn_hls) 
+      !
       IF(lwp) THEN
          WRITE(numout,*)
@@ -98,8 +98,9 @@
       ENDIF
       !
-      IF(  jpni /= 1 .OR. jpnj /= 1 .OR. jpnij /= 1 )                                     &
-         CALL ctl_stop( 'mpp_init: equality  jpni = jpnj = jpnij = 1 is not satisfied',   &
-            &           'the domain is lay out for distributed memory computing!' )
-         !
+#if defined key_agrif
+    IF (.NOT.agrif_root()) THEN
+      call agrif_nemo_init()
+    ENDIF
+#endif
    END SUBROUTINE mpp_init
 
@@ -130,6 +131,4 @@
       !!                    njmpp     : latitudinal  index
       !!                    narea     : number for local area
-      !!                    nlci      : first dimension
-      !!                    nlcj      : second dimension
       !!                    nbondi    : mark for "east-west local boundary"
       !!                    nbondj    : mark for "north-south local boundary"
@@ -142,7 +141,6 @@
       INTEGER ::   ji, jj, jn, jproc, jarea   ! dummy loop indices
       INTEGER ::   inijmin
-      INTEGER ::   i2add
       INTEGER ::   inum                       ! local logical unit
-      INTEGER ::   idir, ifreq, icont         ! local integers
+      INTEGER ::   idir, ifreq                ! local integers
       INTEGER ::   ii, il1, ili, imil         !   -       -
       INTEGER ::   ij, il2, ilj, ijm1         !   -       -
@@ -157,8 +155,8 @@
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   iin, ii_nono, ii_noea          ! 1D workspace
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   ijn, ii_noso, ii_nowe          !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iimppt, ilci, ibondi, ipproc   ! 2D workspace
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ijmppt, ilcj, ibondj, ipolj    !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ilei, ildi, iono, ioea         !  -     -
-      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ilej, ildj, ioso, iowe         !  -     -
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iimppt, ijpi, ibondi, ipproc   ! 2D workspace
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ijmppt, ijpj, ibondj, ipolj    !  -     -
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   iie0, iis0, iono, ioea         !  -     -
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) ::   ije0, ijs0, ioso, iowe         !  -     -
       LOGICAL, ALLOCATABLE, DIMENSION(:,:) ::   llisoce                        !  -     -
       NAMELIST/nambdy/ ln_bdy, nb_bdy, ln_coords_file, cn_coords_file,           &
@@ -168,5 +166,5 @@
            &             cn_ice, nn_ice_dta,                                     &
            &             ln_vol, nn_volctl, nn_rimwidth
-      NAMELIST/nammpp/ jpni, jpnj, ln_nnogather, ln_listonly
+      NAMELIST/nammpp/ jpni, jpnj, nn_hls, ln_nnogather, ln_listonly
       !!----------------------------------------------------------------------
       !
@@ -181,4 +179,5 @@
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'nammpp in configuration namelist' )   
       !
+      nn_hls = MAX(1, nn_hls)   ! nn_hls must be > 0
       IF(lwp) THEN
             WRITE(numout,*) '   Namelist nammpp'
@@ -190,8 +189,15 @@
          ENDIF
             WRITE(numout,*) '      avoid use of mpi_allgather at the north fold  ln_nnogather = ', ln_nnogather
+            WRITE(numout,*) '      halo width (applies to both rows and columns)       nn_hls = ', nn_hls
       ENDIF
       !
       IF(lwm)   WRITE( numond, nammpp )
-
+      !
+!!!------------------------------------
+!!!  nn_hls shloud be read in nammpp
+!!!------------------------------------
+      jpiglo = Ni0glo + 2 * nn_hls
+      jpjglo = Nj0glo + 2 * nn_hls
+      !
       ! do we need to take into account bdy_msk?
       READ  ( numnam_ref, nambdy, IOSTAT = ios, ERR = 903)
@@ -203,10 +209,10 @@
       IF( ln_bdy .AND. ln_mask_file ) CALL iom_open( cn_mask_file, numbdy )
       !
-      IF( ln_listonly )   CALL mpp_init_bestpartition( MAX(mppsize,jpni*jpnj), ldlist = .TRUE. )   ! must be done by all core
+      IF( ln_listonly )   CALL bestpartition( MAX(mppsize,jpni*jpnj), ldlist = .TRUE. )   ! must be done by all core
       !
       !  1. Dimension arrays for subdomains
       ! -----------------------------------
       !
-      ! If dimensions of processor grid weren't specified in the namelist file
+      ! If dimensions of processors grid weren't specified in the namelist file
       ! then we calculate them here now that we have our communicator size
       IF(lwp) THEN
@@ -216,14 +222,14 @@
       ENDIF
       IF( jpni < 1 .OR. jpnj < 1 ) THEN
-         CALL mpp_init_bestpartition( mppsize, jpni, jpnj )           ! best mpi decomposition for mppsize mpi processes
+         CALL bestpartition( mppsize, jpni, jpnj )           ! best mpi decomposition for mppsize mpi processes
          llauto = .TRUE.
          llbest = .TRUE.
       ELSE
          llauto = .FALSE.
-         CALL mpp_init_bestpartition( mppsize, inbi, inbj, icnt2 )    ! best mpi decomposition for mppsize mpi processes
+         CALL bestpartition( mppsize, inbi, inbj, icnt2 )    ! best mpi decomposition for mppsize mpi processes
          ! largest subdomain size for mpi decoposition jpni*jpnj given in the namelist
-         CALL mpp_basic_decomposition( jpni, jpnj, jpimax, jpjmax )
-         ! largest subdomain size for mpi decoposition inbi*inbj given by mpp_init_bestpartition
-         CALL mpp_basic_decomposition( inbi, inbj,  iimax,  ijmax )
+         CALL mpp_basesplit( jpiglo, jpjglo, nn_hls, jpni, jpnj, jpimax, jpjmax )
+         ! largest subdomain size for mpi decoposition inbi*inbj given by bestpartition
+         CALL mpp_basesplit( jpiglo, jpjglo, nn_hls, inbi, inbj,  iimax,  ijmax )
          icnt1 = jpni*jpnj - mppsize   ! number of land subdomains that should be removed to use mppsize mpi processes
          IF(lwp) THEN
@@ -256,5 +262,5 @@
       ! look for land mpi subdomains...
       ALLOCATE( llisoce(jpni,jpnj) )
-      CALL mpp_init_isoce( jpni, jpnj, llisoce )
+      CALL mpp_is_ocean( llisoce )
       inijmin = COUNT( llisoce )   ! number of oce subdomains
 
@@ -265,5 +271,5 @@
          WRITE(ctmp4,*) '   ==>>> There is the list of best domain decompositions you should use: '
          CALL ctl_stop( ctmp1, ctmp2, ctmp3, ' ', ctmp4, ' ' )
-         CALL mpp_init_bestpartition( mppsize, ldlist = .TRUE. )   ! must be done by all core
+         CALL bestpartition( mppsize, ldlist = .TRUE. )   ! must be done by all core
       ENDIF
 
@@ -289,5 +295,5 @@
             WRITE(numout,*)
          ENDIF
-         CALL mpp_init_bestpartition( mppsize, ldlist = .TRUE. )   ! must be done by all core
+         CALL bestpartition( mppsize, ldlist = .TRUE. )   ! must be done by all core
       ENDIF
 
@@ -314,17 +320,14 @@
 9003  FORMAT (a, i5)
 
-      IF( numbot /= -1 )   CALL iom_close( numbot )
-      IF( numbdy /= -1 )   CALL iom_close( numbdy )
-    
-      ALLOCATE(  nfiimpp(jpni,jpnj), nfipproc(jpni,jpnj), nfilcit(jpni,jpnj) ,    &
-         &       nimppt(jpnij) , ibonit(jpnij) , nlcit(jpnij) , nlcjt(jpnij) ,    &
-         &       njmppt(jpnij) , ibonjt(jpnij) , nldit(jpnij) , nldjt(jpnij) ,    &
-         &                                       nleit(jpnij) , nlejt(jpnij) ,    &
+      ALLOCATE(  nfimpp(jpni ) , nfproc(jpni ) ,   nfjpi(jpni ) ,                     &
+         &       nimppt(jpnij) , ibonit(jpnij) ,  jpiall(jpnij) ,  jpjall(jpnij) ,    &
+         &       njmppt(jpnij) , ibonjt(jpnij) , nis0all(jpnij) , njs0all(jpnij) ,    &
+         &                                       nie0all(jpnij) , nje0all(jpnij) ,    &
          &       iin(jpnij), ii_nono(jpnij), ii_noea(jpnij),   &
          &       ijn(jpnij), ii_noso(jpnij), ii_nowe(jpnij),   &
-         &       iimppt(jpni,jpnj), ilci(jpni,jpnj), ibondi(jpni,jpnj), ipproc(jpni,jpnj),   &
-         &       ijmppt(jpni,jpnj), ilcj(jpni,jpnj), ibondj(jpni,jpnj), ipolj(jpni,jpnj),   &
-         &       ilei(jpni,jpnj), ildi(jpni,jpnj), iono(jpni,jpnj), ioea(jpni,jpnj),   &
-         &       ilej(jpni,jpnj), ildj(jpni,jpnj), ioso(jpni,jpnj), iowe(jpni,jpnj),   &
+         &       iimppt(jpni,jpnj), ijpi(jpni,jpnj), ibondi(jpni,jpnj), ipproc(jpni,jpnj),   &
+         &       ijmppt(jpni,jpnj), ijpj(jpni,jpnj), ibondj(jpni,jpnj),  ipolj(jpni,jpnj),   &
+         &         iie0(jpni,jpnj), iis0(jpni,jpnj),   iono(jpni,jpnj),   ioea(jpni,jpnj),   &
+         &         ije0(jpni,jpnj), ijs0(jpni,jpnj),   ioso(jpni,jpnj),   iowe(jpni,jpnj),   &
          &       STAT=ierr )
       CALL mpp_sum( 'mppini', ierr )
@@ -333,9 +336,5 @@
 #if defined key_agrif
       IF( .NOT. Agrif_Root() ) THEN       ! AGRIF children: specific setting (cf. agrif_user.F90)
-         IF( jpiglo /= nbcellsx + 2 + 2*nbghostcells )   &
-            CALL ctl_stop( 'STOP', 'mpp_init: Agrif children requires jpiglo == nbcellsx + 2 + 2*nbghostcells' )
-         IF( jpjglo /= nbcellsy + 2 + 2*nbghostcells )   &
-            CALL ctl_stop( 'STOP', 'mpp_init: Agrif children requires jpjglo == nbcellsy + 2 + 2*nbghostcells' )
-         IF( ln_use_jattr )   CALL ctl_stop( 'STOP', 'mpp_init:Agrif children requires ln_use_jattr = .false. ' )
+         CALL agrif_nemo_init()
       ENDIF
 #endif
@@ -344,9 +343,18 @@
       ! -----------------------------------
       !
-      nreci = 2 * nn_hls
-      nrecj = 2 * nn_hls
-      CALL mpp_basic_decomposition( jpni, jpnj, jpimax, jpjmax, iimppt, ijmppt, ilci, ilcj )
-      nfiimpp(:,:) = iimppt(:,:)
-      nfilcit(:,:) = ilci(:,:)
+      CALL mpp_basesplit( jpiglo, jpjglo, nn_hls, jpni, jpnj, jpimax, jpjmax, iimppt, ijmppt, ijpi, ijpj )
+      CALL mpp_getnum( llisoce, ipproc, iin, ijn )
+      !
+      !DO jn = 1, jpni
+      !   jproc = ipproc(jn,jpnj)
+      !   ii = iin(jproc+1)
+      !   ij = ijn(jproc+1)
+      !   nfproc(jn) = jproc
+      !   nfimpp(jn) = iimppt(ii,ij)
+      !   nfjpi (jn) =   ijpi(ii,ij)
+      !END DO
+      nfproc(:) = ipproc(:,jpnj) 
+      nfimpp(:) = iimppt(:,jpnj) 
+      nfjpi (:) =   ijpi(:,jpnj)
       !
       IF(lwp) THEN
@@ -357,7 +365,8 @@
          WRITE(numout,*) '      jpni = ', jpni  
          WRITE(numout,*) '      jpnj = ', jpnj
+         WRITE(numout,*) '     jpnij = ', jpnij
          WRITE(numout,*)
-         WRITE(numout,*) '      sum ilci(i,1) = ', sum(ilci(:,1)), ' jpiglo = ', jpiglo
-         WRITE(numout,*) '      sum ilcj(1,j) = ', sum(ilcj(1,:)), ' jpjglo = ', jpjglo
+         WRITE(numout,*) '      sum ijpi(i,1) = ', sum(ijpi(:,1)), ' jpiglo = ', jpiglo
+         WRITE(numout,*) '      sum ijpj(1,j) = ', sum(ijpj(1,:)), ' jpjglo = ', jpjglo
       ENDIF
      
@@ -374,6 +383,6 @@
          ii = 1 + MOD(iarea0,jpni)
          ij = 1 +     iarea0/jpni
-         ili = ilci(ii,ij)
-         ilj = ilcj(ii,ij)
+         ili = ijpi(ii,ij)
+         ilj = ijpj(ii,ij)
          ibondi(ii,ij) = 0                         ! default: has e-w neighbours
          IF( ii   ==    1 )   ibondi(ii,ij) = -1   ! first column, has only e neighbour
@@ -390,8 +399,8 @@
          ioea(ii,ij) = iarea0 + 1
          iono(ii,ij) = iarea0 + jpni
-         ildi(ii,ij) =  1  + nn_hls
-         ilei(ii,ij) = ili - nn_hls
-         ildj(ii,ij) =  1  + nn_hls
-         ilej(ii,ij) = ilj - nn_hls
+         iis0(ii,ij) =  1  + nn_hls
+         iie0(ii,ij) = ili - nn_hls
+         ijs0(ii,ij) =  1  + nn_hls
+         ije0(ii,ij) = ilj - nn_hls
 
          ! East-West periodicity: change ibondi, ioea, iowe
@@ -431,34 +440,4 @@
       ! ----------------------------
       !
-      ! specify which subdomains are oce subdomains; other are land subdomains
-      ipproc(:,:) = -1
-      icont = -1
-      DO jarea = 1, jpni*jpnj
-         iarea0 = jarea - 1
-         ii = 1 + MOD(iarea0,jpni)
-         ij = 1 +     iarea0/jpni
-         IF( llisoce(ii,ij) ) THEN
-            icont = icont + 1
-            ipproc(ii,ij) = icont
-            iin(icont+1) = ii
-            ijn(icont+1) = ij
-         ENDIF
-      END DO
-      ! if needed add some land subdomains to reach jpnij active subdomains
-      i2add = jpnij - inijmin
-      DO jarea = 1, jpni*jpnj
-         iarea0 = jarea - 1
-         ii = 1 + MOD(iarea0,jpni)
-         ij = 1 +     iarea0/jpni
-         IF( .NOT. llisoce(ii,ij) .AND. i2add > 0 ) THEN
-            icont = icont + 1
-            ipproc(ii,ij) = icont
-            iin(icont+1) = ii
-            ijn(icont+1) = ij
-            i2add = i2add - 1
-         ENDIF
-      END DO
-      nfipproc(:,:) = ipproc(:,:)
-
       ! neighbour treatment: change ibondi, ibondj if next to a land zone
       DO jarea = 1, jpni*jpnj
@@ -499,15 +478,4 @@
          ENDIF
       END DO
-
-      ! Update il[de][ij] according to modified ibond[ij]
-      ! ----------------------
-      DO jproc = 1, jpnij
-         ii = iin(jproc)
-         ij = ijn(jproc)
-         IF( ibondi(ii,ij) == -1 .OR. ibondi(ii,ij) == 2 ) ildi(ii,ij) =  1
-         IF( ibondi(ii,ij) ==  1 .OR. ibondi(ii,ij) == 2 ) ilei(ii,ij) = ilci(ii,ij)
-         IF( ibondj(ii,ij) == -1 .OR. ibondj(ii,ij) == 2 ) ildj(ii,ij) =  1
-         IF( ibondj(ii,ij) ==  1 .OR. ibondj(ii,ij) == 2 ) ilej(ii,ij) = ilcj(ii,ij)
-      END DO
       
       ! 5. Subdomain print
@@ -522,5 +490,5 @@
             DO jj = jpnj, 1, -1
                WRITE(numout,9403) ('   ',ji=il1,il2-1)
-               WRITE(numout,9402) jj, (ilci(ji,jj),ilcj(ji,jj),ji=il1,il2)
+               WRITE(numout,9402) jj, (ijpi(ji,jj),ijpj(ji,jj),ji=il1,il2)
                WRITE(numout,9404) (ipproc(ji,jj),ji=il1,il2)
                WRITE(numout,9403) ('   ',ji=il1,il2-1)
@@ -579,36 +547,31 @@
       noea = ii_noea(narea)
       nono = ii_nono(narea)
-      nlci = ilci(ii,ij)  
-      nldi = ildi(ii,ij)
-      nlei = ilei(ii,ij)
-      nlcj = ilcj(ii,ij)  
-      nldj = ildj(ii,ij)
-      nlej = ilej(ii,ij)
+      jpi    = ijpi(ii,ij)  
+!!$      Nis0  = iis0(ii,ij)
+!!$      Nie0  = iie0(ii,ij)
+      jpj    = ijpj(ii,ij)  
+!!$      Njs0  = ijs0(ii,ij)
+!!$      Nje0  = ije0(ii,ij)
       nbondi = ibondi(ii,ij)
       nbondj = ibondj(ii,ij)
       nimpp = iimppt(ii,ij)  
       njmpp = ijmppt(ii,ij)
-      jpi = nlci
-      jpj = nlcj
-      jpk = jpkglo                                             ! third dim
-#if defined key_agrif
-      ! simple trick to use same vertical grid as parent but different number of levels: 
-      ! Save maximum number of levels in jpkglo, then define all vertical grids with this number.
-      ! Suppress once vertical online interpolation is ok
-!!$      IF(.NOT.Agrif_Root())   jpkglo = Agrif_Parent( jpkglo )
-#endif
-      jpim1 = jpi-1                                            ! inner domain indices
-      jpjm1 = jpj-1                                            !   "           "
-      jpkm1 = MAX( 1, jpk-1 )                                  !   "           "
-      jpij  = jpi*jpj                                          !  jpi x j
+      jpk = jpkglo                              ! third dim
+      !
+      CALL init_doloop                          ! set start/end indices of do-loop, depending on the halo width value (nn_hls) 
+      !
+      jpim1 = jpi-1                             ! inner domain indices
+      jpjm1 = jpj-1                             !   "           "
+      jpkm1 = MAX( 1, jpk-1 )                   !   "           "
+      jpij  = jpi*jpj                           !  jpi x j
       DO jproc = 1, jpnij
          ii = iin(jproc)
          ij = ijn(jproc)
-         nlcit(jproc) = ilci(ii,ij)
-         nldit(jproc) = ildi(ii,ij)
-         nleit(jproc) = ilei(ii,ij)
-         nlcjt(jproc) = ilcj(ii,ij)
-         nldjt(jproc) = ildj(ii,ij)
-         nlejt(jproc) = ilej(ii,ij)
+         jpiall (jproc) = ijpi(ii,ij)
+         nis0all(jproc) = iis0(ii,ij)
+         nie0all(jproc) = iie0(ii,ij)
+         jpjall (jproc) = ijpj(ii,ij)
+         njs0all(jproc) = ijs0(ii,ij)
+         nje0all(jproc) = ije0(ii,ij)
          ibonit(jproc) = ibondi(ii,ij)
          ibonjt(jproc) = ibondj(ii,ij)
@@ -624,10 +587,10 @@
          WRITE(inum,'(6i8,a,3i8,a)') jpnij,jpimax,jpjmax,jpk,jpiglo,jpjglo,&
    &           ' ( local: ',narea,jpi,jpj,' )'
-         WRITE(inum,'(a)') 'nproc nlci nlcj nldi nldj nlei nlej nimp njmp nono noso nowe noea nbondi nbondj '
+         WRITE(inum,'(a)') 'nproc   jpi  jpj Nis0 Njs0 Nie0 Nje0 nimp njmp nono noso nowe noea nbondi nbondj '
 
          DO jproc = 1, jpnij
-            WRITE(inum,'(13i5,2i7)')   jproc-1, nlcit  (jproc), nlcjt  (jproc),   &
-               &                                nldit  (jproc), nldjt  (jproc),   &
-               &                                nleit  (jproc), nlejt  (jproc),   &
+            WRITE(inum,'(13i5,2i7)')   jproc-1,  jpiall(jproc),  jpjall(jproc),   &
+               &                                nis0all(jproc), njs0all(jproc),   &
+               &                                nie0all(jproc), nje0all(jproc),   &
                &                                nimppt (jproc), njmppt (jproc),   & 
                &                                ii_nono(jproc), ii_noso(jproc),   &
@@ -663,11 +626,6 @@
          WRITE(numout,*) '    l_Iperio = ', l_Iperio
          WRITE(numout,*) '    l_Jperio = ', l_Jperio
-         WRITE(numout,*) '      nlci   = ', nlci
-         WRITE(numout,*) '      nlcj   = ', nlcj
          WRITE(numout,*) '      nimpp  = ', nimpp
          WRITE(numout,*) '      njmpp  = ', njmpp
-         WRITE(numout,*) '      nreci  = ', nreci  
-         WRITE(numout,*) '      nrecj  = ', nrecj  
-         WRITE(numout,*) '      nn_hls = ', nn_hls 
       ENDIF
 
@@ -691,14 +649,12 @@
       ENDIF
       !
-      CALL mpp_init_ioipsl       ! Prepare NetCDF output file (if necessary)
+      CALL init_ioipsl       ! Prepare NetCDF output file (if necessary)
       !      
       IF (( jperio >= 3 .AND. jperio <= 6 .AND. jpni > 1 ).AND.( ln_nnogather )) THEN
-         CALL mpp_init_nfdcom     ! northfold neighbour lists
+         CALL init_nfdcom     ! northfold neighbour lists
          IF (llwrtlay) THEN
             WRITE(inum,*)
             WRITE(inum,*)
             WRITE(inum,*) 'north fold exchanges with explicit point-to-point messaging :'
-            WRITE(inum,*) 'nfsloop : ', nfsloop
-            WRITE(inum,*) 'nfeloop : ', nfeloop
             WRITE(inum,*) 'nsndto : ', nsndto
             WRITE(inum,*) 'isendto : ', isendto
@@ -710,13 +666,14 @@
       DEALLOCATE(iin, ijn, ii_nono, ii_noea, ii_noso, ii_nowe,    &
          &       iimppt, ijmppt, ibondi, ibondj, ipproc, ipolj,   &
-         &       ilci, ilcj, ilei, ilej, ildi, ildj,              &
+         &       ijpi, ijpj, iie0, ije0, iis0, ijs0,              &
          &       iono, ioea, ioso, iowe, llisoce)
       !
     END SUBROUTINE mpp_init
 
-
-    SUBROUTINE mpp_basic_decomposition( knbi, knbj, kimax, kjmax, kimppt, kjmppt, klci, klcj)
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE mpp_basic_decomposition  ***
+#endif
+
+    SUBROUTINE mpp_basesplit( kiglo, kjglo, khls, knbi, knbj, kimax, kjmax, kimppt, kjmppt, klci, klcj)
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE mpp_basesplit  ***
       !!                    
       !! ** Purpose :   Lay out the global domain over processors.
@@ -730,4 +687,6 @@
       !!                    klcj       : second dimension
       !!----------------------------------------------------------------------
+      INTEGER,                                 INTENT(in   ) ::   kiglo, kjglo
+      INTEGER,                                 INTENT(in   ) ::   khls
       INTEGER,                                 INTENT(in   ) ::   knbi, knbj
       INTEGER,                                 INTENT(  out) ::   kimax, kjmax
@@ -736,14 +695,15 @@
       !
       INTEGER ::   ji, jj
+      INTEGER ::   i2hls 
       INTEGER ::   iresti, irestj, irm, ijpjmin
-      INTEGER ::   ireci, irecj
-      !!----------------------------------------------------------------------
+      !!----------------------------------------------------------------------
+      i2hls = 2*khls
       !
 #if defined key_nemocice_decomp
-      kimax = ( nx_global+2-2*nn_hls + (knbi-1) ) / knbi + 2*nn_hls    ! first  dim.
-      kjmax = ( ny_global+2-2*nn_hls + (knbj-1) ) / knbj + 2*nn_hls    ! second dim. 
+      kimax = ( nx_global+2-i2hls + (knbi-1) ) / knbi + i2hls    ! first  dim.
+      kjmax = ( ny_global+2-i2hls + (knbj-1) ) / knbj + i2hls    ! second dim. 
 #else
-      kimax = ( jpiglo - 2*nn_hls + (knbi-1) ) / knbi + 2*nn_hls    ! first  dim.
-      kjmax = ( jpjglo - 2*nn_hls + (knbj-1) ) / knbj + 2*nn_hls    ! second dim.
+      kimax = ( kiglo - i2hls + (knbi-1) ) / knbi + i2hls    ! first  dim.
+      kjmax = ( kjglo - i2hls + (knbj-1) ) / knbj + i2hls    ! second dim.
 #endif
       IF( .NOT. PRESENT(kimppt) ) RETURN
@@ -752,25 +712,23 @@
       ! -----------------------------------
       !  Computation of local domain sizes klci() klcj()
-      !  These dimensions depend on global sizes knbi,knbj and jpiglo,jpjglo
+      !  These dimensions depend on global sizes knbi,knbj and kiglo,kjglo
       !  The subdomains are squares lesser than or equal to the global
       !  dimensions divided by the number of processors minus the overlap array.
       !
-      ireci = 2 * nn_hls
-      irecj = 2 * nn_hls
-      iresti = 1 + MOD( jpiglo - ireci -1 , knbi )
-      irestj = 1 + MOD( jpjglo - irecj -1 , knbj )
+      iresti = 1 + MOD( kiglo - i2hls - 1 , knbi )
+      irestj = 1 + MOD( kjglo - i2hls - 1 , knbj )
       !
       !  Need to use kimax and kjmax here since jpi and jpj not yet defined
 #if defined key_nemocice_decomp
       ! Change padding to be consistent with CICE
-      klci(1:knbi-1      ,:) = kimax
-      klci(knbi          ,:) = jpiglo - (knbi - 1) * (kimax - nreci)
-      klcj(:,      1:knbj-1) = kjmax
-      klcj(:,          knbj) = jpjglo - (knbj - 1) * (kjmax - nrecj)
+      klci(1:knbi-1,:       ) = kimax
+      klci(  knbi  ,:       ) = kiglo - (knbi - 1) * (kimax - i2hls)
+      klcj(:       ,1:knbj-1) = kjmax
+      klcj(:       ,  knbj  ) = kjglo - (knbj - 1) * (kjmax - i2hls)
 #else
       klci(1:iresti      ,:) = kimax
       klci(iresti+1:knbi ,:) = kimax-1
-      IF( MINVAL(klci) < 3 ) THEN
-         WRITE(ctmp1,*) '   mpp_basic_decomposition: minimum value of jpi must be >= 3'
+      IF( MINVAL(klci) < 2*i2hls ) THEN
+         WRITE(ctmp1,*) '   mpp_basesplit: minimum value of jpi must be >= ', 2*i2hls
          WRITE(ctmp2,*) '   We have ', MINVAL(klci)
         CALL ctl_stop( 'STOP', ctmp1, ctmp2 )
@@ -778,19 +736,17 @@
       IF( jperio == 3 .OR. jperio == 4 .OR. jperio == 5 .OR. jperio == 6 ) THEN
          ! minimize the size of the last row to compensate for the north pole folding coast
-         IF( jperio == 3 .OR. jperio == 4 )   ijpjmin = 5   ! V and F folding involves line jpj-3 that must not be south boundary
-         IF( jperio == 5 .OR. jperio == 6 )   ijpjmin = 4   ! V and F folding involves line jpj-2 that must not be south boundary
-         irm = knbj - irestj                                    ! total number of lines to be removed
-         klcj(:,            knbj) = MAX( ijpjmin, kjmax-irm )   ! we must have jpj >= ijpjmin in the last row
-         irm = irm - ( kjmax - klcj(1,knbj) )                   ! remaining number of lines to remove 
-         irestj = knbj - 1 - irm                        
-         klcj(:,        1:irestj) = kjmax
+         IF( jperio == 3 .OR. jperio == 4 )   ijpjmin = 2+3*khls   ! V and F folding must be outside of southern halos
+         IF( jperio == 5 .OR. jperio == 6 )   ijpjmin = 1+3*khls   ! V and F folding must be outside of southern halos
+         irm = knbj - irestj                                       ! total number of lines to be removed
+         klcj(:,knbj) = MAX( ijpjmin, kjmax-irm )                  ! we must have jpj >= ijpjmin in the last row
+         irm = irm - ( kjmax - klcj(1,knbj) )                      ! remaining number of lines to remove 
+         irestj = knbj - 1 - irm
          klcj(:, irestj+1:knbj-1) = kjmax-1
       ELSE
-         ijpjmin = 3
-         klcj(:,      1:irestj) = kjmax
-         klcj(:, irestj+1:knbj) = kjmax-1
-      ENDIF
-      IF( MINVAL(klcj) < ijpjmin ) THEN
-         WRITE(ctmp1,*) '   mpp_basic_decomposition: minimum value of jpj must be >= ', ijpjmin
+         klcj(:, irestj+1:knbj  ) = kjmax-1
+      ENDIF
+      klcj(:,1:irestj) = kjmax
+      IF( MINVAL(klcj) < 2*i2hls ) THEN
+         WRITE(ctmp1,*) '   mpp_basesplit: minimum value of jpj must be >= ', 2*i2hls
          WRITE(ctmp2,*) '   We have ', MINVAL(klcj)
          CALL ctl_stop( 'STOP', ctmp1, ctmp2 )
@@ -806,5 +762,5 @@
          DO jj = 1, knbj
             DO ji = 2, knbi
-               kimppt(ji,jj) = kimppt(ji-1,jj) + klci(ji-1,jj) - ireci
+               kimppt(ji,jj) = kimppt(ji-1,jj) + klci(ji-1,jj) - i2hls
             END DO
          END DO
@@ -814,15 +770,15 @@
          DO jj = 2, knbj
             DO ji = 1, knbi
-               kjmppt(ji,jj) = kjmppt(ji,jj-1) + klcj(ji,jj-1) - irecj
+               kjmppt(ji,jj) = kjmppt(ji,jj-1) + klcj(ji,jj-1) - i2hls
             END DO
          END DO
       ENDIF
       
-   END SUBROUTINE mpp_basic_decomposition
-
-
-   SUBROUTINE mpp_init_bestpartition( knbij, knbi, knbj, knbcnt, ldlist )
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE mpp_init_bestpartition  ***
+   END SUBROUTINE mpp_basesplit
+
+
+   SUBROUTINE bestpartition( knbij, knbi, knbj, knbcnt, ldlist )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE bestpartition  ***
       !!
       !! ** Purpose :
@@ -830,5 +786,5 @@
       !! ** Method  :
       !!----------------------------------------------------------------------
-      INTEGER,           INTENT(in   ) ::   knbij         ! total number if subdomains               (knbi*knbj)
+      INTEGER,           INTENT(in   ) ::   knbij         ! total number of subdomains (knbi*knbj)
       INTEGER, OPTIONAL, INTENT(  out) ::   knbi, knbj    ! number if subdomains along i and j (knbi and knbj)
       INTEGER, OPTIONAL, INTENT(  out) ::   knbcnt        ! number of land subdomains
@@ -838,4 +794,5 @@
       INTEGER :: iszitst, iszjtst
       INTEGER :: isziref, iszjref
+      INTEGER :: iszimin, iszjmin
       INTEGER :: inbij, iszij
       INTEGER :: inbimax, inbjmax, inbijmax, inbijold
@@ -866,6 +823,11 @@
       inbimax = 0
       inbjmax = 0
-      isziref = jpiglo*jpjglo+1
+      isziref = jpiglo*jpjglo+1   ! define a value that is larger than the largest possible
       iszjref = jpiglo*jpjglo+1
+      !
+      iszimin = 4*nn_hls          ! minimum size of the MPI subdomain so halos are always adressing neighbor inner domain
+      iszjmin = 4*nn_hls
+      IF( jperio == 3 .OR. jperio == 4 )   iszjmin = MAX(iszjmin, 2+3*nn_hls)   ! V and F folding must be outside of southern halos
+      IF( jperio == 5 .OR. jperio == 6 )   iszjmin = MAX(iszjmin, 1+3*nn_hls)   ! V and F folding must be outside of southern halos
       !
       ! get the list of knbi that gives a smaller jpimax than knbi-1
